;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-beginner-abbr-reader.ss" "lang")((modname Hausi10_v2_070118) (read-case-sensitive #t) (teachpacks ((lib "universe.rkt" "teachpack" "2htdp") (lib "image.rkt" "teachpack" "2htdp"))) (htdp-settings #(#t quasiquote repeating-decimal #f #t none #f ((lib "universe.rkt" "teachpack" "2htdp") (lib "image.rkt" "teachpack" "2htdp")) #f)))
(require 2htdp/abstraction)

(define-struct literal (value))
(define-struct addition (lhs rhs))
(define-struct subtraction (lhs rhs))
(define-struct multiplication (lhs rhs))
(define-struct division (lhs rhs))

; An Expression is one of:
; - (make-literal Number)
; - (make-literal Boolean)
; - (make-addition Expression Expression)
; - (make-subtraction Expression Expression)
; - (make-multiplication Expression Expression)
; - (make-division Expression Expression)
; - (make-equality Expression Expression)
; - (make-conditional Expression Expression Expression)
; interp. abstract syntax tree of arithmetic expressions

(define EXPRESSION-1 (make-literal 42))

(define EXPRESSION-2
  (make-addition (make-literal 4) (make-multiplication (make-literal 5) (make-literal 8))))

(define EXPRESSION-3
  (make-division (make-subtraction (make-literal 11) (make-literal 7)) (make-literal 2)))


; Any -> Boolean
; checks whether e is an Expression
(check-expect (expression? EXPRESSION-1) #true)
(check-expect (expression? EXPRESSION-2) #true)
(check-expect (expression? EXPRESSION-3) #true)
(check-expect (expression? (make-literal "42")) #false)
(check-expect (expression? (make-literal #false)) #true)
(check-expect (expression? (make-equality (make-literal #true) (make-literal #true))) #true)
(check-expect (expression? (make-conditional (make-literal 45) (make-literal #true) (make-literal 4))) #false)
(check-expect (expression? (make-conditional (make-literal #true) (make-literal #false) (make-literal #false))) #true)
(check-expect (expression? (make-division (make-literal 4) (make-literal 4))) #true)
(check-expect (expression? #true) #false)
(define (expression? e)
  (match e
    [(literal v) (or (number? v)
                     (boolean? v))]
    [(addition l r) (and (expression? l) (expression? r))]
    [(subtraction l r) (and (expression? l) (expression? r))]
    [(multiplication l r) (and (expression? l) (expression? r))]
    [(division l r) (and (expression? l) (expression? r))]
    [(equality l r) (and (expression? l) (expression? r))]
    [(conditional c t f) (and (expression? c) (boolean? (evaluate c)))]
    [else #false]))

; A Value is one of
; - a Number
; - a Boolean
; interp. a value is the final result of evaluating an expression.


; Expression -> Value
; computes the value of an arithmetic expression
(check-expect (evaluate EXPRESSION-1) 42)
(check-expect (evaluate EXPRESSION-2) 44)
(check-expect (evaluate EXPRESSION-3) 2)
(check-expect (evaluate (make-equality (make-literal 8) (make-literal 5))) #false)
(check-expect (evaluate (make-equality (make-literal #true) (make-literal #true))) #true)
(check-expect (evaluate (make-conditional (make-literal #false) (make-literal #false) (make-literal #true))) #true)
(define (evaluate expr)
  (match expr
    [(literal v) v]
    [(addition l r) (+ (evaluate l) (evaluate r))]
    [(subtraction l r) (- (evaluate l) (evaluate r))]
    [(multiplication l r) (* (evaluate l) (evaluate r))]
    [(division l r) (/ (evaluate l) (evaluate r))]
    [(equality l r) (cond
                      [(and (boolean? (evaluate l))
                            (boolean? (evaluate r))) (and (evaluate l) (evaluate r))]
                      [(and (number? (evaluate l))
                            (number? (evaluate r))) (= (evaluate l) (evaluate r))])]
    [(conditional c t f) (if (evaluate c) (evaluate t) (evaluate f))]))


(define EXPRESSION-4 (make-addition (make-literal 85) (make-literal 4)))
(define S-EXPRESSION-1 42)
(define S-EXPRESSION-2 `(+ 4 (* 5 8)))
(define S-EXPRESSION-3 `(/ (- 11 7) 2))
(define S-EXPRESSION-4a '(+ 85 4))
(define S-EXPRESSION-5a '(* 52 (/ 4 2)))
(define S-EXPRESSION-6a '(- (* 8 2) (/ (+ 3 2) 5)))

; Expression -> S-Expression
; converts an expression into the corresponding S-Expression
(check-expect (expr->sexpr EXPRESSION-4) S-EXPRESSION-4a)
(check-expect (expr->sexpr (make-multiplication (make-literal 52) (make-division (make-literal 4) (make-literal 2)))) S-EXPRESSION-5a)
(check-expect (expr->sexpr (make-subtraction (make-multiplication (make-literal 8) (make-literal 2))
                                             (make-division (make-addition (make-literal 3) (make-literal 2))
                                                            (make-literal 5)))) S-EXPRESSION-6a)
(define (expr->sexpr e)
  (match e
    [(literal v) v]
    [(addition l r) `(+ ,(expr->sexpr l) ,(expr->sexpr r))]
    [(subtraction l r) `(- ,(expr->sexpr l) ,(expr->sexpr r))]
    [(multiplication l r) `(* ,(expr->sexpr l) ,(expr->sexpr r))]
    [(division l r) `(/ ,(expr->sexpr l) ,(expr->sexpr r))]
    [(equality l r) `(= ,(expr->sexpr l) ,(expr->sexpr r))]
    [(conditional c t f) `(if ,(expr->sexpr c) ,(expr->sexpr t) ,(expr->sexpr f))]))

; S-Expression -> Expression
; tries to convert an S-Expression to an arithmetic expression,
; and throws an error if this is not possible.
(check-expect (sexpr->expr 4) (make-literal 4)) 
(check-expect (sexpr->expr '(+ 1 2)) (make-addition (make-literal 1) (make-literal 2)))
(check-error (sexpr->expr '(+ "Hello" 42)))
(check-expect (sexpr->expr S-EXPRESSION-4a) (make-addition (make-literal 85) (make-literal 4)))
(check-expect (sexpr->expr S-EXPRESSION-5a) (make-multiplication (make-literal 52)
                                                                 (make-division (make-literal 4)
                                                                                (make-literal 2))))
(check-expect (sexpr->expr `(- 5 1)) (make-subtraction (make-literal 5)
                                                        (make-literal 1)))
(define (sexpr->expr sexpr)
  (match sexpr
    [(or (? number?)
         (? boolean?)) (make-literal sexpr)]
    [`(+ ,l ,r) (make-addition (sexpr->expr l) (sexpr->expr r))]
    [`(- ,l ,r) (make-subtraction (sexpr->expr l) (sexpr->expr r))]
    [`(* ,l ,r) (make-multiplication (sexpr->expr l) (sexpr->expr r))]
    [`(/ ,l ,r) (make-division (sexpr->expr l) (sexpr->expr r))]
    [`(= ,l ,r) (make-equality (sexpr->expr l) (sexpr->expr r))]
    [`(if ,c ,t ,f) (make-conditional (sexpr->expr c) (sexpr->expr t) (sexpr->expr f))]
    [else (error "sexpr->expr: Input is not an S-Expression")]))

; An S-EXPRESSION is one of
; - number
; - boolean
; - `(+ S-EXPRESSION S-EXPRESSION)
; - `(- S-EXPRESSION S-EXPRESSION)
; - `(* S-EXPRESSION S-EXPRESSION)
; - `(/ S-EXPRESSION S-EXPRESSION)
; - `(= S-EXPRESSION S-EXPRESSION)
; - `(if (= S-EXPRESSION S-EXPRESSION) S-EXPRESSION S-EXPRESSION)
; - 

; Erweiterung von Expression um Wahrheitswerte
; --------------------------------------------
; Bitte erweitern Sie die obige Datendefinition für Expressions
; wie auf dem Aufgabenblatt beschrieben!

(define-struct equality (lhs rhs))
(define-struct conditional (condition true-branch false-branch))

(define S-EXPRESSION-4 '(if (= 1 1) 2 3))
(define S-EXPRESSION-5 '(if (= 1 0) 2 #true))

(check-expect (evaluate (sexpr->expr S-EXPRESSION-4))  2)
(check-expect (evaluate (sexpr->expr S-EXPRESSION-5))  #true)
(check-expect (expr->sexpr (sexpr->expr S-EXPRESSION-5)) S-EXPRESSION-5)

;; s-expression?
;;
;; S-Expression -> Boolean
;; checks, if a given thing is an s-expression
;(define (s-expression? s)
;  [match s
;    [(


; S-Expression -> S-Expression
; Desugars all uses of and, or, not and cond into (potentially nested) ifs.
(check-expect (desugar `(+ 1 2)) `(+ 1 2))
(check-expect (desugar `(- 1 2)) `(- 1 2))
(check-expect (desugar `(* 1 2)) `(* 1 2))
(check-expect (desugar `(/ 1 2)) `(/ 1 2))
(check-expect (desugar `(= 1 2)) `(= 1 2))
(check-expect (desugar '(and #true #false)) '(if #true (if #false #true #false) #false))
(check-expect (desugar `(or #false #true)) `(if #false #true #true))
(check-expect (desugar `(not #false)) `(if #false #false #true))
(check-expect (desugar `4) 4)
(check-expect (desugar `#true) #true)
;(check-expect (desugar `(cond [#true 22])) `(if #true 22 0))
(check-expect (desugar `(cond [#false 45] [else 46])) `(if #false 45 46))
(check-expect (desugar `(cond [#false 54] [else 74])) `(if #false 54 74))
;(check-expect (desugar `(cond [#true 47])) `(if #true 47 0))
(check-expect (desugar `(cond (#false 14) (else 1904))) `(if #false 14 1904))
(check-expect (desugar `(cond [(and #true #true) 1] [else 2])) `(if (if #true (if #true #true #false) #false) 1 2))
(check-expect (desugar `(cond [(and #true #false) 1] [else 3]))
              `(if (if #true (if #false #true #false) #false) 1 3))
(check-expect (desugar `(cond [(and #true #false) 1] [(or #false #true) 2] [else 3]))
              `(if (if #true (if #false #true #false) #false) 1 (if (if #false #true #true) 2 3)))
(check-expect (desugar `(cond ((and #true #true) 1) (else 2)))
              `(if (if #true (if #true #true #false) #false) 1 2))

(define (desugar sexpr)
  (match sexpr
    [(or (? boolean?) (? number?)) sexpr]
    [(or `(+ ,l ,r)
         `(- ,l ,r)
         `(* ,l ,r)
         `(/ ,l ,r)
         `(= ,l ,r)) sexpr]
    [`(and ,l ,r) `(if ,(desugar l) (if ,(desugar r) #true #false) #false)]
    [`(or ,l ,r) `(if ,(desugar l) #true ,(desugar r))]
    [`(not ,x) `(if ,(desugar x) #false #true)]
   ; [`(cond , `[else ,y]) (desugar y)]
    ;[(cons `cond (cons (cons x (cons y empty)) xs)) `(if ,(desugar y) ,(desugar (cons `cond xs)))]
    ;[`(cond [#false ,x1] ,x2) `(if #false ,(desugar x1) ,(desugar `(cond ,x2)))]
    [`(cond [,x ,y] ,xs) `(if ,(desugar x) ,(desugar y) ,(desugar `(cond ,xs)))]
   ; [`(cond [,x1 ,x2] ,x3) `(if ,(desugar x1) ,(desugar x2) ,(desugar `(cond ,x3)))]
    ;[`(cond [#true ,x2]) `(if #true ,(desugar x2) 0)]
    [`(cond [else ,x2]) (desugar x2)]
    ;[`(cond [else ,x2]) `(if #true ,(desugar x2) 0)]
  ;  [`(cond ,x1 ,x2)`(if ,(desugar (first x1)) ,(desugar (second x1)) ,(desugar `(cond ,(first x2) ,(second x2))))]
    ))


; Geben Sie Aufgabe 4 bitte im Forum ab und tragen Sie hier den Link zu Ihrem Forenthema ein:
;
;      >>> https://forum-ps.informatik.uni-tuebingen.de/t/goats-of-every-nba-franchise/5551 <<<

